function bdShowHide() {
    var a = 'blind';
    if (choo.bd.apv) {
        $('.bd-hidemech').show(a);
        $('.bd-hideapv').hide();
        if (choo.bd.vw) {
            $('.bd-hidevw').hide();
            $('.bd-hidevv').show(a)
        } else {
            $('.bd-hidevw').show(a);
            $('.bd-hidevv').hide()
        }
    } else {
        $('.bd-hidemech').hide();
        $('.bd-hideapv').show(a)
    }
    return
}

function calcBattDrain() {
    var a = [];
    var b = choo.bd;
    if (!b.apv) {
        b.battcurr = b.battu / b.attyres;
        b.battpow = b.battcurr * b.battu;
        $('.attyresultscol').hide()
    } else {
        if (b.vw) {
            b.coilpow = b.vwset;
            b.coilu = Math.sqrt(b.coilpow * b.attyres);
            b.coilcurr = b.coilu / b.attyres
        } else {
            b.coilu = b.vvset;
            b.coilcurr = b.coilu / b.attyres;
            b.coilpow = b.coilu * b.coilcurr
        }
        a.push('<tr>');
        a.push('<td>电压</td>');
        a.push('<td class="text-right">' + round(b.coilu, 2) + '</td>');
        a.push('<td>V</td>');
        a.push('</tr>');
        a.push('<tr>');
        a.push('<td>电流</td>');
        a.push('<td class="text-right">' + round(b.coilcurr, 2) + '</td>');
        a.push('<td>A</td>');
        a.push('</tr>');
        a.push('<tr>');
        a.push('<td>功率</td>');
        a.push('<td class="text-right">' + round(b.coilpow, 2) + '</td>');
        a.push('<td>W</td>');
        a.push('</tr>');
        $('.attyresultscol').show();
        $('#bd-attyresults').html(a.join(''));
        b.battpow = b.coilpow / b.effic;
        b.battcurr = b.battpow / b.battu
    }
    a = [];
    a.push('<tr>');
    a.push('<tr>');
    a.push('<td>电压</td>');
    a.push('<td class="text-right">' + round(b.battu, 2) + '</td>');
    a.push('<td>V</td>');
    a.push('</tr>');
    a.push('<td>电流</td>');
    a.push('<td class="text-right">' + round(b.battcurr, 2) + '</td>');
    a.push('<td>A</td>');
    a.push('</tr>');
    a.push('<tr>');
    a.push('<td>功率</td>');
    a.push('<td class="text-right">' + round(b.battpow, 2) + '</td>');
    a.push('<td>W</td>');
    a.push('</tr>');
    $('#bd-battresults').html(a.join(''));
    a = [];
    b.amplimit = (b.battcap / 1000) * b.crating;
    a.push('<tr title="电池容量乘以C等级">');
    a.push('<td>功放限制</td>');
    a.push('<td class="text-right">' + round(b.amplimit, 2) + '</td>');
    a.push('<td>A</td>');
    a.push('</tr>');
    b.amplimitpercent = (b.battcurr / b.amplimit) * 100;
    a.push('<tr>');
    a.push('<td>功放限制余量<small>@ ' + b.battu + ' V</small></td>');
    if (b.amplimitpercent > 100) {
        a.push('<td class="text-right danger" title="Overcurrent">' + round(100 - b.amplimitpercent, 0) + '</td>')
    } else if (b.amplimitpercent > 90) {
        a.push('<td class="text-right danger" title="几乎没有余量 - 你应该至少有20％的余量">' + round(100 - b.amplimitpercent, 0) + '</td>')
    } else if (b.amplimitpercent > 80) {
        a.push('<td class="text-right warning" title="你应该至少有20％的余量">' + round(100 - b.amplimitpercent, 0) + '</td>')
    } else if (b.amplimitpercent > 70) {
        a.push('<td class="text-right">' + round(100 - b.amplimitpercent, 0) + '</td>')
    } else {
        a.push('<td class="text-right success">' + round(100 - b.amplimitpercent, 0) + '</td>')
    }
    a.push('<td>%</td>');
    a.push('</tr>');
    $('#bd-battlimit').html(a.join(''));
    a = [];
    b.battcappow = (b.battcap / 1000) * b.nomu;
    a.push('<tr>');
    a.push('<td>电池容量<small class="text-muted">@ ' + b.nomu + ' V</small></td>');
    a.push('<td class="text-right">' + round(b.battcappow, 2) + '</td>');
    a.push('<td title="Watt-hours">Wh</td>');
    a.push('</tr>');
    var c, tmpNomP;
    if (b.apv) {
        b.battime = (b.battcappow / b.battpow) * 60
    } else {
        c = b.nomu / b.attyres;
        tmpNomP = b.nomu * c;
        tmpNomP /= b.effic;
        a.push('<tr>');
        a.push('<td>"标称"动力<small class="text-muted">' + b.nomu + ' V @ ' + b.attyres + ' &ohm;</small></td>');
        a.push('<td class="text-right">' + round(tmpNomP, 2) + '</td>');
        a.push('<td>W</td>');
        a.push('</tr>');
        b.battime = (b.battcappow / tmpNomP) * 60
    }
    a.push('<tr title="测试电池在持续放电时的使用时长">');
    a.push('<td>预计总运行时间</td>');
    a.push('<td class="text-right">' + round(b.battime, 0) + '</td>');
    a.push('<td>最小</td>');
    a.push('</tr>');
    b.battpuffs = (b.battime / (5 / 60));
    a.push('<tr>');
    a.push('<td>预估可吐烟圈次数<small class="text-muted">@ 5秒</small></td>');
    a.push('<td class="text-right">' + round(b.battpuffs, 0) + '</td>');
    a.push('<td><i class="glyphicon glyphicon-cloud text-muted"></i></td>');
    a.push('</tr>');
    $('#bd-battruntime').html(a.join(''));
    $('#bd-battlimitpanel').show();
    $('#bd-battruntimepanel').show();
    setHelpClass($('.panel'));
    return
}

function bdReadValues() {
    var a = choo.bd;
    a.apv = ($('#bd-pv-apv').is(':checked'));
    a.vw = ($('#bd-mode-vw').is(':checked'));
    a.attyres = readNumber($('#bd-attyres').val());
    a.vvset = readNumber($('#bd-vapeu').val());
    a.vwset = readNumber($('#bd-vapep').val());
    a.battu = readNumber($('#bd-battu').val());
    if (a.apv) {
        a.effic = parseInt($('#bd-effic').val(), 10) / 100
    } else {
        a.effic = 1
    }
    a.nomu = readNumber($('#bd-nomu').val());
    if (a.attyres < 0.1) {
        a.attyres = 0.1;
        $('#bd-attyres').val(a.attyres)
    }
    if (a.vvset < 0.1) {
        a.vvset = 0.1;
        $('#bd-vapeu').val(a.vvset)
    }
    if (a.vwset < 0.1) {
        a.vwset = 0.1;
        $('#bd-vapep').val(a.vwset)
    }
    if (a.battu < 0.1) {
        a.battu = 0.1;
        $('#bd-battu').val(a.battu)
    }
    if (a.effic > 1) {
        a.effic = 1;
        $('#bd-battu').val(a.battu);
        $('#bd-effic').val(round(a.effic * 100, 0))
    } else if (a.effic < 0.01) {
        a.effic = 0.01;
        $('#bd-effic').val(round(a.effic * 100, 0))
    }
    a.battcap = readNumber($('#bd-battcap').val());
    a.crating = readNumber($('#bd-crating').val());
    return
}

function bdWriteValues() {
    var a = choo.bd;
    if (a.apv) {
        $('#bd-pv-apv').prop('checked', true)
    } else {
        $('#bd-pv-mech').prop('checked', true)
    } if (a.vw) {
        $('#bd-mode-vw').prop('checked', true)
    } else {
        $('#bd-mode-vv').prop('checked', true)
    }
    $('#bd-attyres').val(a.attyres);
    $('#bd-vapeu').val(a.vvset);
    $('#bd-vapep').val(a.vwset);
    $('#bd-battu').val(a.battu);
    $('#bd-effic').val(round(a.effic * 100, 0));
    $('#bd-battcap').val(a.battcap);
    $('#bd-crating').val(round(a.crating, 2));
    $('#bd-nomu').val(a.nomu);
    return
}

function initBattDrain() {
    return {
    apv: false,
    vw: false,
    attyres: 1.8,
    vvset: 3.7,
    vwset: 7.5,
    battu: 4.2,
    effic: 0.9,
    battcap: 700,
    crating: 5,
    nomu: 3.7
    }
}

function bdLoad() {
    var a = seLoad('bd');
    if (a === undefined) {
        choo.bd = initBattDrain();
        $('#bd-load').hide()
    } else {
        if (a.nomu === undefined) {
            a.nomu = 3.7
        }
        choo.bd = a
    }
    bdWriteValues();
    calcBattDrain();
    bdShowHide();
    return
}

function setBattPre() {
    var a = choo.bd;
    var b = $('#bd-battpre').find(':selected');
    if (b.val() === '') {
        return false
    }
    if (b.val() === 'unknown') {
        feedbackModal('电池预设推荐', '<p><strong>如果你没有找到预设中你的电池，你可以手动计算器进入统计。</strong></p><p>如果你也想你的电池，以在未来的某个预设上市，你可以在这里建议它。请填写所有需要的规格。<strong>不完整的申请将被删除。</strong> 没有所有的所需功能，它是不可能计算任何有用的东西。</p>', '你可以看看下面的电池中的预设列表:\nName (厂商/模型) (必填): \n容量 (mAh) (必填): \nC 评级/功放漏电 (必填): \n额定电压 (默认 3.7V):');
        $('.modal-body').find('textarea').css('height', '10em');
        return false
    }
    var c = b.attr('data-battcap');
    if (c === '') {
        return
    }
    var d = b.attr('data-nomu');
    var e = b.attr('data-crating');
    a.battcap = parseFloat(c);
    if (d === undefined) {
        a.nomu = 3.7
    } else {
        a.nomu = parseFloat(d)
    }
    a.crating = parseFloat(e);
    bdWriteValues();
    calcBattDrain();
    var f = '预设只是为了方便，请勿盲目信任。请务必确认容量，额定电压和C等级。';
    if (b.attr('title') !== undefined) {
        ccMenuMsg('<p>提示: ' + b.attr('title') + '</p><p>' + f + '</p>', 'danger', 16000)
    } else {
        ccMenuMsg('<p>提示: ' + f + '</p>', 'warning', 8000)
    }
    return {
    nm: b.attr('data-nm'),
    mah: b.attr('data-battcap'),
    c: b.attr('data-crating')
    }
}

function makeBattPresetOptions(a) {
    choo.bd.bpresets = a;
    var b = [];
    var c;
    var d;
    for (d = 0; d < choo.bd.bpresets.length; d++) {
        c = choo.bd.bpresets[d];
        if (c.a) {
            c.c = (c.a * 1000 / c.q)
        }
        b.push('<option class="notranslate" data-battcap="' + c.q + '" data-crating="' + c.c + '" data-nm="' + c.nm + '" value="' + c.nm + ',' + c.q + ',' + c.c + '"');
        if (c.t !== undefined) {
            b.push(' title="' + c.t + '"')
        }
        b.push('>');
        b.push(c.nm + ' (' + c.q + ' mAh, ');
        if (c.a) {
            b.push(c.a + 'A');
            b.push(' = ' + round(c.c, 2) + 'C')
        } else {
            b.push(c.c + 'C')
        }
        b.push(')');
        b.push('</option>')
    }
    $('#bd-battpre').html('<option data-battcap=""></option>' + b.join(''));
    return
}

function getPresets() {
    var b = $('#presetjson');
    if (b.length > 0) {
        makeBattPresetOptions($.parseJSON(b.text()))
    } else {
        $.getJSON('batt-presets-cn.json', function(a) {
                  makeBattPresetOptions(a)
                  }).fail(function() {
                          console.warn('无法加载数据');
                          $('#bd-battpre').html('<option value=""></option><option value="">无法加载数据</option>')
                          })
    }
    return
}

function startBatt() {
    bdLoad();
    bdWriteValues();
    getPresets();
    $('#bd-pv-radio input').change(function() {
                                   bdReadValues();
                                   calcBattDrain();
                                   bdShowHide();
                                   gad('batt', 'apv', bool2int(choo.bd.apv))
                                   });
    $('#bd-mode-radio input').change(function() {
                                     var a = choo.bd;
                                     bdReadValues();
                                     a.vwset = a.coilpow;
                                     a.vvset = a.coilu;
                                     calcBattDrain();
                                     if (a.vw) {
                                     $('#bd-vapep').val(round(a.vwset, 1))
                                     } else {
                                     $('#bd-vapeu').val(round(a.vvset, 1))
                                     }
                                     bdShowHide();
                                     gad('batt', 'vw', bool2int(a.vw))
                                     });
    $('input.form-control').change(function() {
                                   bdReadValues();
                                   calcBattDrain();
                                   gad('batt', 'calc')
                                   });
    $('#bd-reset').click(function() {
                         choo.bd = initBattDrain();
                         bdWriteValues();
                         calcBattDrain();
                         bdShowHide();
                         ccMenuMsg('已恢复默认设置', 'success');
                         gad('batt', 'reset')
                         });
    $('#bd-save').click(function() {
                        var a = choo.bd;
                        seSave('bd', a);
                        $('#bd-load').show();
                        gad('batt', 'save')
                        });
    $('#bd-load').click(function() {
                        bdLoad();
                        gad('batt', 'load')
                        });
    $('#bd-battpre').change(function() {
                            $('.fade5').remove();
                            var a = setBattPre();
                            if (a === false) {
                            return
                            }
                            if (a.nm === undefined) {
                            updateQs('?')
                            } else {
                            updateQs('&b=' + a.nm.replace(/ /g, '_') + '&mah=' + a.mah + '&c=' + a.c);
                            gad('batt', 'preset', a.nm)
                            }
                            return
                            });
    var b = getQueryStrings();
    if (Object.keys(b).length > 0) {
        var c = b.b.replace(/_/g, ' ');
        setTimeout(function() {
                   $('#bd-battpre').val(c + ',' + b.mah + ',' + b.c);
                   setBattPre()
                   }, 1000)
    }
    bdShowHide();
    calcBattDrain();
    return
}
$(document).ready(function() {
                  startBatt()
                  });