var mr = {
r: []
};

function dround(a) {
    if (a < 1) {
        return round(a, 3)
    }
    if (a < 10) {
        return round(a, 2)
    }
    return round(a, 1)
}

function updateChart() {
    var a;
    var b = [];
    var c = choo.modr.rmin || 0;
    var d = choo.modr.rmax || 5;
    var e = d - c;
    var f = 30;
    var g = e / f;
    c = Math.round(c * f, 0) / f;
    for (a = c; a <= d; a += g) {
        b.push(round(a, 2))
    }
    b = [];
    var h;
    for (a = 0; a < 125; a++) {
        h = a / 50;
        b.push(h)
    }
    var i = [];
    for (a = 0; a < b.length; a++) {
        if (b[a] < choo.modr.rmin || b[a] > choo.modr.rmax) {
            i.push(0)
        } else {
            i.push(choo.modr.imax * choo.modr.imax * b[a])
        }
    }
    var j = [];
    for (a = 0; a < b.length; a++) {
        if (b[a] < choo.modr.rmin || b[a] > choo.modr.rmax) {
            j.push(0)
        } else {
            j.push((choo.modr.umax) * choo.modr.umax / b[a])
        }
    }
    var k = [];
    for (a = 0; a < b.length; a++) {
        k.push(Math.min(i[a], j[a], choo.modr.pmax))
    }
    var l = [{
             data: k,
             fillColor: "rgba(220,255,220,0.2)"
             }];
    var m = [];
    for (a = 0; a < b.length; a++) {
        if (round(b[a] * 4, 3) === round(b[a] * 4, 0)) {
            m.push(b[a])
        } else {
            m.push('')
        }
    }
    var n = {
    labels: m,
    datasets: l
    };
    $('#mrangechart').html('<canvas id="mainchart" ></canvas>');
    choo.modr.linje = new Chart($('#mainchart').get(0).getContext("2d"));
    choo.modr.linje.Line(n, {
                         bezierCurve: false,
                         animation: false,
                         responsive: true,
                         maintainAspectRatio: false,
                         pointDot: false,
                         scaleGridLineColor: "rgba(0,0,0,.1)",
                         datasetFill: true,
                         showTooltips: false
                         });
    return
}

function findMaxPower() {
    choo.modr.umax = parseFloat($('#umax').val());
    choo.modr.pmax = parseFloat($('#pmax').val());
    choo.modr.rmin = parseFloat($('#rmin').val());
    choo.modr.rmax = parseFloat($('#rmax').val());
    choo.modr.imax = parseFloat($('#imax').val());
    $('#res').find('.imax').html(choo.modr.imax);
    $('#res').find('.umax').html(choo.modr.umax);
    $('#res').find('.pmax').html(choo.modr.pmax);
    $('#res').find('.rmin').html(choo.modr.rmin);
    $('#res').find('.rmax').html(choo.modr.rmax);
    choo.modr.ufromi = choo.modr.pmax / choo.modr.imax;
    $('#res1').find('.ures').html(dround(choo.modr.ufromi));
    if (choo.modr.ufromi > choo.modr.umax) {
        $('#res1 .maxu').show();
        choo.modr.ufromi = choo.modr.umax
    } else {
        $('#res1 .maxu').hide()
    }
    choo.modr.minres = choo.modr.ufromi / choo.modr.imax;
    $('#res1').find('.rres').html(dround(choo.modr.minres));
    if (choo.modr.minres < choo.modr.rmin) {
        $('#res1 .minr').show();
        $('#res1 .maxr').hide();
        choo.modr.minres = choo.modr.rmin
    } else if (choo.modr.minres > choo.modr.rmax) {
        $('#res1 .minr').hide();
        $('#res1 .maxr').show();
        choo.modr.minres = choo.modr.rmax
    } else {
        $('#res1 .minr').hide();
        $('#res1 .maxr').hide()
    }
    $('#res3').find('.rmin').html(dround(choo.modr.minres));
    choo.modr.ifromu = choo.modr.pmax / choo.modr.umax;
    $('#res2').find('.ires').html(dround(choo.modr.ifromu));
    if (choo.modr.ifromu > choo.modr.imax) {
        choo.modr.ifromu = choo.modr.imax;
        $('#res2 .maxi').show()
    } else {
        $('#res2 .maxi').hide()
    }
    choo.modr.maxres = choo.modr.umax / choo.modr.ifromu;
    $('#res2').find('.rres').html(dround(choo.modr.maxres));
    if (choo.modr.maxres < choo.modr.rmin) {
        $('#res2 .minr').show();
        $('#res2 .maxr').hide();
        choo.modr.maxres = choo.modr.rmin
    } else if (choo.modr.maxres > choo.modr.rmax) {
        $('#res2 .minr').hide();
        $('#res2 .maxr').show();
        choo.modr.maxres = choo.modr.rmax
    } else {
        $('#res2 .minr').hide();
        $('#res2 .maxr').hide()
    }
    $('#res3').find('.rmax').html(dround(choo.modr.maxres));
    choo.modr.median = choo.modr.umax / choo.modr.imax;
    if (choo.modr.median < choo.modr.rmin) {
        $('#res3 .rmid').html('<s title="中值電阻小于最低歐姆" class="text-muted helpcursor">' + dround(choo.modr.median) + '</s> ' + dround(choo.modr.rmin));
        choo.modr.limitedmedian = choo.modr.rmin
    } else if (choo.modr.median > choo.modr.rmax) {
        $('#res3 .rmid').html('<s title="中值電阻大于最低歐姆" class="text-muted helpcursor">' + dround(choo.modr.median) + '</s> ' + dround(choo.modr.rmax));
        choo.modr.limitedmedian = choo.modr.rmax
    } else {
        $('#res3 .rmid').html(dround(choo.modr.median));
        choo.modr.limitedmedian = choo.modr.median
    }
    choo.modr.sweet = (choo.modr.maxres + choo.modr.limitedmedian) / 2;
    $('#res3 .rsweet').html(dround(choo.modr.sweet));
    var a = [];
    if (choo.modr.minres === choo.modr.maxres) {
        a.push('<code>無最大功率範圍</code> 考慮增加功率（瓦數），增大電流或電壓，或增加電阻範圍。');
        $('#res3 .panel-footer').show()
    } else {
        $('#res3 .panel-footer').hide()
    }
    $('#res3 .panel-footer .help-block').html(a.join(''));
    if (typeof Chart === 'function') {
        updateChart()
    } else {
        console.warn('表格無法加載')
    }
    return
}

function getPresetId(a) {
    var b;
    for (b = 0; b < mr.presets.length; b++) {
        if (mr.presets[b].chipnm === a) {
            return b
        }
    }
    console.warn('Could not find id for ' + a);
    return
}

function makePresetDropdown(a) {
    mr.presets = a;
    var b, xx = [],
    tmp;
    xx.push('<option value=""></option>');
    for (b = 0; b < mr.presets.length; b++) {
        if (mr.presets[b].chip) {
            tmp = getPresetId(mr.presets[b].chip);
            xx.push('<option value="' + tmp + '" class="notranslate syn">' + mr.presets[b].nm + ' (' + mr.presets[tmp].nm + ')</option>')
        } else {
            xx.push('<option value="' + b + '" class="notranslate">' + mr.presets[b].nm + '</option>')
        }
    }
    $('#modpreset').html(xx.join(''));
    return
}

function getPresets() {
    var b = $('#presetjson');
    if (b.length > 0) {
        makePresetDropdown($.parseJSON(b.text()))
    } else {
        $.getJSON('modrange-presets.json', function(a) {
                  makePresetDropdown(a)
                  }).fail(function() {
                          $('#modpreset').html('<option value=""></option><option value="">不能加載預設值</option>')
                          })
    }
    return
}
$(document).ready(function() {
                  choo.modr = {};
                  findMaxPower();
                  $('input').change(function() {
                                    findMaxPower()
                                    });
                  $('#modpreset').change(function() {
                                         var a = $(this).val();
                                         if (a === '') {
                                         return
                                         }
                                         var b = mr.presets[a];
                                         if (b.umin === undefined) {
                                         b.umin = 0
                                         }
                                         if (b.umax === undefined) {
                                         b.umax = 999
                                         }
                                         if (b.pmin === undefined) {
                                         b.pmin = 0
                                         }
                                         if (b.pmax === undefined) {
                                         b.pmax = 999
                                         }
                                         if (b.imax === undefined) {
                                         b.imax = 999
                                         }
                                         $('#umin').val(dround(b.umin));
                                         $('#umax').val(dround(b.umax));
                                         $('#pmin').val(dround(b.pmin));
                                         $('#pmax').val(dround(b.pmax));
                                         $('#imax').val(dround(b.imax));
                                         if (b.rmin === undefined) {
                                         b.rmin = 0.01;
                                         $('#rmin').val('')
                                         } else {
                                         $('#rmin').val(dround(b.rmin))
                                         } if (b.rmax === undefined) {
                                         b.rmax = 999;
                                         $('#rmax').val('')
                                         } else {
                                         $('#rmax').val(dround(b.rmax))
                                         }
                                         findMaxPower();
                                         gad('modrange', 'preset', $(this).find('option:selected').html().replace(/ /g, '_'))
                                         });
                  $('#hidesyns').click(function() {
                                       if ($(this).is(':checked')) {
                                       $('#modpreset option.syn').hide()
                                       } else {
                                       $('#modpreset option.syn').show()
                                       }
                                       });
                  getPresets()
                  });