var ej = {
flavor: []
};

function ejShowRes(a) {
    var b = [],
    cl = '',
    tmpTitle = '',
    ok = true,
    tmpCss = '';
    if (a < 0) {
        cl = ' danger';
        tmpTitle = '负数说明当前组合不适用';
        tmpCss = ' style="cursor:help;"';
        ok = false
    }
    if (ej.sh.ml) {
        b.push('<td class="text-right' + cl + '" title="' + tmpTitle + '"' + tmpCss + '>' + round(a, 2) + '</td>')
    }
    if (ej.sh.cl) {
        b.push('<td class="text-right' + cl + '" title="' + tmpTitle + '"' + tmpCss + '>' + round(a / 10, 2) + '</td>')
    }
    if (ej.sh.dl) {
        b.push('<td class="text-right' + cl + '" title="' + tmpTitle + '"' + tmpCss + '>' + round(a / 100, 2) + '</td>')
    }
    if (ej.sh.l) {
        b.push('<td class="text-right' + cl + '" title="' + tmpTitle + '"' + tmpCss + '>' + round(a / 1000, 2) + '</td>')
    }
    return {
    html: b.join(''),
    ok: ok
    }
}

function calculateJuice() {
    var a;
    ej.nicBaseNonnicP = 100 - ej.nicBaseNicP;
    ej.nicBaseRealVgP = ej.nicBaseVgP * (ej.nicBaseNonnicP / 100);
    ej.nicBaseRealPgP = ej.nicBasePgP * (ej.nicBaseNonnicP / 100);
    ej.nicTargetVol = ej.batch * ej.targetNicP / 100;
    ej.nicBaseVol = ej.nicTargetVol / (ej.nicBaseNicP / 100);
    ej.nicBaseNicVol = (ej.targetNicP / 100) * ej.batch;
    ej.nicBasePgVol = ej.nicBaseVol * (ej.nicBaseRealPgP / 100);
    ej.nicBaseVgVol = ej.nicBaseVol * (ej.nicBaseRealVgP / 100);
    ej.targetPgVol = (ej.targetPgP / 100) * (ej.batch - ej.nicBaseNicVol);
    ej.targetVgVol = (ej.targetVgP / 100) * (ej.batch - ej.nicBaseNicVol);
    ej.addPgVol = ej.targetPgVol - ej.nicBasePgVol;
    ej.addVgVol = ej.targetVgVol - ej.nicBaseVgVol;
    if (ej.flavor) {
        for (a = 0; a < ej.flavor.length; a++) {
            ej.flavor[a].vol = ej.batch * (ej.flavor[a].perc / 100);
            if (ej.flavor[a].vg) {
                ej.addVgVol -= ej.flavor[a].vol
            } else {
                ej.addPgVol -= ej.flavor[a].vol
            }
        }
    }
    var b;
    var c, tmpOk = true;
    b = [];
    b.push('<thead>');
    b.push('<tr>');
    b.push('<th>成分</th>');
    b.push('<th class="text-right">' + ej.batchUnit + '</th>');
    b.push('</tr>');
    b.push('</thead>');
    b.push('<tbody>');
    b.push('<tr>');
    b.push('<td>尼古丁</td>');
    c = ejShowRes(round(ej.nicBaseNicVol, 2));
    b.push(c.html);
    if (!c.ok) {
        tmpOk = false
    }
    b.push('</tr>');
    b.push('<tr>');
    b.push('<td>VG</td>');
    c = ejShowRes(round(ej.nicBaseVgVol, 2));
    b.push(c.html);
    if (!c.ok) {
        tmpOk = false
    }
    b.push('</tr>');
    b.push('<td>PG</td>');
    c = ejShowRes(round(ej.nicBasePgVol, 2));
    b.push(c.html);
    if (!c.ok) {
        tmpOk = false
    }
    b.push('</tr>');
    b.push('</tbody>');
    $('#ej-breakdown').html(b.join(''));
    b = [];
    b.push('<thead>');
    b.push('<tr>');
    b.push('<th>成分</th>');
    b.push('<th class="text-right">' + ej.batchUnit + '</th>');
    b.push('</tr>');
    b.push('</thead>');
    b.push('<tbody>');
    b.push('<tr>');
    b.push('<td>尼古丁</td>');
    c = ejShowRes(round(ej.nicBaseNicVol, 2));
    b.push(c.html);
    if (!c.ok) {
        tmpOk = false
    }
    b.push('</tr>');
    b.push('<tr>');
    b.push('<td>VG</td>');
    c = ejShowRes(ej.targetVgVol);
    b.push(c.html);
    if (!c.ok) {
        tmpOk = false
    }
    b.push('</tr>');
    b.push('<tr>');
    b.push('<td>PG</td>');
    c = ejShowRes(ej.targetPgVol);
    b.push(c.html);
    if (!c.ok) {
        tmpOk = false
    }
    b.push('</tr>');
    b.push('</tbody>');
    $('#ej-ingredients').html(b.join(''));
    b = [];
    b.push('<thead>');
    b.push('<tr>');
    b.push('<th>成分</th>');
    b.push('<th class="text-right">' + ej.batchUnit + '</th>');
    b.push('</tr>');
    b.push('</thead>');
    b.push('<tbody>');
    b.push('<tr>');
    b.push('<td>烟碱');
    if (ej.nicBaseVgP === 100) {
        b.push(' (VG)')
    } else if (ej.nicBasePgP === 100) {
        b.push(' (PG)')
    } else {
        b.push(' (PG/VG)')
    }
    b.push('</td>');
    c = ejShowRes(ej.nicBaseVol);
    b.push(c.html);
    if (!c.ok) {
        tmpOk = false
    }
    b.push('</tr>');
    if (ej.flavor) {
        for (a = 0; a < ej.flavor.length; a++) {
            b.push('<tr>');
            b.push('<td><i>' + ej.flavor[a].nm + ' (');
            if (ej.flavor[a].vg) {
                b.push('VG')
            } else {
                b.push('PG')
            }
            b.push(')</i></td>');
            b.push(ejShowRes(ej.flavor[a].vol).html);
            b.push('</tr>')
        }
    }
    b.push('<tr>');
    b.push('<td>VG</td>');
    c = ejShowRes(ej.addVgVol);
    b.push(c.html);
    if (!c.ok) {
        tmpOk = false
    }
    b.push('</tr>');
    b.push('<tr>');
    b.push('<td>PG</td>');
    c = ejShowRes(ej.addPgVol);
    b.push(c.html);
    if (!c.ok) {
        tmpOk = false
    }
    b.push('</tr>');
    b.push('</tbody>');
    $('#ej-results').html(b.join(''));
    activateBlinkies($('#ej-results'));
    var d = [];
    if (ej.nicBaseNicP < ej.targetNicP) {
        d.push('<p>目标尼古丁含量比基液的尼古丁含量高，您应该改用更强的尼古丁基液，或降低目标尼古丁浓度。</p>');
        tmpOk = false
    }
    var e = $('#ej-errormsg');
    if (!tmpOk) {
        d.push('<p>');
        d.push('该组合不适用');
        d.push('需要降低尼古丁含量,或者减少VG，PG，调料.');
        d.push('另外,可以使用更强的尼古丁基液或者含有不同VG/PG比例的尼古丁基液');
        d.push('请调整您的设置');
        d.push('</p>');
        e.html('<div class="alert alert-danger blinky" data-blink="#ej-results td.danger">' + d.join('') + '</div>');
        if (!e.is(':visible')) {
            e.slideDown(200)
        }
    } else {
        if (e.is(':visible')) {
            e.slideUp(200)
        }
    }
    return
}

function defaultJuice() {
    return {
    batch: 10,
    sh: {
    ml: true,
    cl: false,
    dl: false,
    l: false
    },
    batchUnit: 'ml',
    nicUnit: 'p',
    nicBaseNicP: 2.7,
    nicBasePgP: 100,
    nicBaseVgP: 0,
    targetNicP: 1.8,
    targetPgP: 70,
    targetVgP: 30,
    flavor: [],
    title: 'Recipe 1',
    notes: ''
    }
}

function addFlavor(a, b, c, d) {
    var x = [];
    x.push('<tr>');
    x.push('<td><input class="form-control input-sm flavor-nm" name="flavorName" value="' + a + '" /><input type="hidden" name="flavorId" value="'+d+'"/></td>');
    x.push('<td><i class="glyphicon glyphicon-remove text-muted"></i></td>');
    x.push('<td><input class="form-control input-sm text-right flavor-percent" type="number" value="' + b + '" /></td>');
    x.push('<td class="text-center"><input type="checkbox" class="flavor-vg"');
    if (c) {
        x.push(' checked="checked"')
    }
    x.push(' /></td>');
    x.push('</tr>');
    $('#ej-flavoring').append(x.join(''));
    return
}

function writeFlavors() {
    var a;
    var b = ej.flavor;
    if (b.length === 0) {
        addFlavor('Flavor', 0, false,'0')
    } else {
        for (a = 0; a < b.length; a++) {
            addFlavor(b[a].nm, b[a].perc, b[a].vg,b[a].id)
        }
    }
    return
}

function writeJuice() {
    $('#ej-batch').val(ej.batch);
    $('#ej-nicbasepgp').val(ej.nicBasePgP);
    $('#ej-nicbasevgp').val(ej.nicBaseVgP);
    $('#ej-targetpgp').val(ej.targetPgP);
    $('#ej-targetvgp').val(ej.targetVgP);
    $('#ej-batch-u').find('input').prop('checked', false);
    var a = '#ej-batch-u-' + ej.batchUnit;
    $(a).prop('checked', true);
    if (ej.nicUnit === 'm') {
        $('#ej-nic-unit-disclaimer').show('slideDown');
        $('#ej-nic-unit-p').prop('checked', false);
        $('#ej-nic-unit-mgml').prop('checked', true);
        $('.ej-nic-unit span').html('<sup>mg</sup>/<sub>ml</sub>');
        $('#ej-nicbasenicp').val(ej.nicBaseNicP * 10);
        $('#ej-targetnicp').val(ej.targetNicP * 10)
    } else {
        $('#ej-nic-unit-disclaimer').hide();
        $('#ej-nic-unit-mgml').prop('checked', false);
        $('#ej-nic-unit-p').prop('checked', true);
        $('.ej-nic-unit span').html('%');
        $('#ej-nicbasenicp').val(ej.nicBaseNicP);
        $('#ej-targetnicp').val(ej.targetNicP)
    }
    return
}

function getFlavors() {
    ej.flavor = [];
    $('#ej-flavoring tr').each(function() {
            ej.flavor.push({
                nm: $(this).find('.flavor-nm').val(),
                 perc: parseFloat($(this).find('.flavor-percent').val()),
                 vg: $(this).find('.flavor-vg').is(':checked'),
                 id: $(this).find('input[name=flavorId]').val()
             })
      });
    return
}

function startJuice(obj) {
    var a = obj?obj:seLoad('ej');
    if (a) {
        ej = a;
        writeFlavors();
        writeJuice()
    } else {
        ej = defaultJuice();
        writeJuice();
        $('#ej-load').hide()
    }
    $('#ej-batch').change(function() {
                          ej.batch = parseFloat($(this).val());
                          calculateJuice();
                          gad('juice', 'batch', ej.batch)
                          });
    $('#ej-batch-unit').find('input').change(function() {
                                             ej.batchUnit = $(this).val();
                                             $('#ej-batch-addon span').html(ej.batchUnit);
                                             calculateJuice();
                                             gad('juice', 'batchunit', ej.batchUnit)
                                             });
    $('#ej-nic-unit').find('input').change(function() {
                                           if ($('#ej-nic-unit-p').is(':checked')) {
                                           ej.nicUnit = 'p'
                                           } else {
                                           ej.nicUnit = 'm'
                                           }
                                           writeJuice();
                                           ej.nicBaseNicP = parseFloat($('#ej-nicbasenicp').val());
                                           if (ej.nicUnit === 'm') {
                                           ej.nicBaseNicP /= 10
                                           }
                                           calculateJuice();
                                           gad('juice', 'nicunit', ej.nicUnit)
                                           });
    $('#ej-nicbasenicp').change(function() {
                                ej.nicBaseNicP = parseFloat($(this).val());
                                if (ej.nicUnit === 'm') {
                                ej.nicBaseNicP /= 10
                                }
                                calculateJuice();
                                gad('juice', 'nicbasenicp', ej.nicBaseNicP)
                                });
    $('#ej-nicbasepgp').change(function() {
                               ej.nicBasePgP = parseFloat($(this).val());
                               ej.nicBaseVgP = 100 - ej.nicBasePgP;
                               $('#ej-nicbasevgp').val(ej.nicBaseVgP);
                               calculateJuice();
                               gad('juice', 'nicbasepgp', ej.nicBasePgP)
                               });
    $('#ej-nicbasevgp').change(function() {
                               ej.nicBaseVgP = parseFloat($(this).val());
                               ej.nicBasePgP = 100 - ej.nicBaseVgP;
                               $('#ej-nicbasepgp').val(ej.nicBasePgP);
                               calculateJuice();
                               gad('juice', 'nicbasevgp', ej.nicBaseVgP)
                               });
    $('#ej-targetnicp').change(function() {
                               ej.targetNicP = parseFloat($(this).val());
                               if (ej.nicUnit === 'm') {
                               ej.targetNicP /= 10
                               }
                               calculateJuice();
                               gad('juice', 'targetnicp', ej.targetNicP)
                               });
    $('#ej-targetpgp').change(function() {
                              ej.targetPgP = parseFloat($(this).val());
                              ej.targetVgP = 100 - ej.targetPgP;
                              $('#ej-targetvgp').val(ej.targetVgP);
                              gad('juice', 'targptpgp', ej.targetPgP);
                              calculateJuice()
                              });
    $('#ej-targetvgp').change(function() {
                              ej.targetVgP = parseFloat($(this).val());
                              ej.targetPgP = 100 - ej.targetVgP;
                              $('#ej-targetpgp').val(ej.targetPgP);
                              gad('juice', 'targetvgp', ej.targetVgP);
                              calculateJuice()
                              });
    $('#ej-save').click(function() {
                        seSave('ej', ej);
                        $('#ej-load').show();
                        gad('juice', 'save')
                        });
    $('#ej-load').click(function() {
                        a = seLoad('ej');
                        ej = a;
                        $('#ej-flavoring').html('');
                        writeFlavors();
                        writeJuice();
                        calculateJuice();
                        gad('juice', 'load')
                        });
    $('#ej-reset').click(function() {
                         ej = defaultJuice();
                         $('#ej-flavoring').html('');
                         writeJuice();
                         calculateJuice();
                         ccMenuMsg('默认配置导入成功', 'success');
                         gad('juice', 'reset')
                         });
    $('#ej-addflavor').click(function() {
                             gad('juice', 'flavor', 'add');
                             addFlavor('Flavor ' + (ej.flavor.length + 1), 0, false);
                             getFlavors();
                             calculateJuice()
                             });
    $('#ej-flavoring').on('change', 'input', function() {
                          gad('juice', 'flavor', 'change');
                          getFlavors();
                          calculateJuice()
                          });
    $('#ej-flavoring').on('click', '.glyphicon-remove', function() {
                          gad('juice', 'flavor', 'remove');
                          $(this).parents('tr').remove();
                          getFlavors();
                          calculateJuice()
                          });
    var inputObj = null;
    $('#ej-flavoring').on('input', 'input[name=flavorName]', function() {
                          var val = $(this).val();
                          console.log(val);
                          inputObj = $(this);
                          if(val.length == 0){
                          $("#showLayer").slideUp('fast');
                          }else{
                          fetchName(val,$(this));
                          }
                          });
    
    $("#showLayer").on('click', 'a.vendorName', function() {
                       var dataId = $(this).attr("data-id");
                       var dataName = $(this).text();
                       console.log(dataId);
                       if (inputObj) {
                       inputObj.val(dataName);
                       }
                       if (dataId) {
                       inputObj.next().val(dataId);
                       }
                       $("#showLayer").slideUp('fast');
                       });
    $("#titleID").on('change', 'input[name=recipeName]', function(){
                     ej.title = $(this).val();
                     console.log(ej.title);
                                             });
    
    $("#notesID").on('change keyup paste', function(){
                     ej.notes = $(this).val();
                     console.log(ej.notes);
    });
    
    if (ej.flavor.length > 0) {
        setTimeout(function() {
                   $('#ej-flavoring-collapse').collapse('show');
                   }, 500)
    }
    if (ej.title){
        $("input[name=recipeName]").val(ej.title);
    }
    if (ej.notes){
        $("#notesID").val(ej.notes);
    }
    calculateJuice();
    return
}

function connectWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) {
        callback(WebViewJavascriptBridge)
    } else {
        document.addEventListener('WebViewJavascriptBridgeReady', function() {
                                  callback(WebViewJavascriptBridge);
                                  }, false);
    }
}

connectWebViewJavascriptBridge(function(bridge) {
       bridge.init(function(message, responseCallback) {
                   console.log('JS message', ej);
                   if (message){
                        responseCallback({'code':200});
                   }
        });
                        
       bridge.registerHandler('INIT', function(data, responseCallback) {
            console.log('init:'+data);
            if(data){
                if (!data.diy){
                    $("#NotesId").hide();
                }
                if (!$.isEmptyObject(data.recipeId)){
                    ej.id = data.recipeId;
                }else{
                    delete ej.id;
                }
                if (!$.isEmptyObject(data.recipeData)){
                    startJuice(data.recipeData);
                }
            }
       });
       
       bridge.registerHandler('GetFlavorData', function(data, responseCallback) {
              console.log("++++++"+ej);
              responseCallback(ej);
       });
});

function fetchName(str,obj){
    var requestUrl = "http://api.vapeam.com/flavors_suggestion?jsoncallback=?";
    $.getJSON(requestUrl,{"kw":str},function(json){
              if (json.error == 0) {
              var list = json.data.list;
              var html = '<ul>';
              for (var i = list.length - 1; i >= 0; i--) {
              html += '<li><a data-id="'+list[i].id+'" class="vendorName">'+list[i].term+'</a></li>';
              }
              html+= '</ul>';
              $("#showLayer").html(html)
              .slideDown('fast')
              .css({'left':obj.offset().left,
                   top:obj.offset().top+28,
                   width:$("#ej-flavoring").outerWidth(true)-4});
              }
              });
}

$(document).ready(function() {
                  startJuice()
                  });