var choo = {
timeouts: {},
adblokket: false
};

function gad(a, b, c) {
    clearTimeout(choo.timeouts[a + '-' + b]);
    choo.timeouts[a + '-' + b] = setTimeout(function() {
                                            ga('send', 'event', a, b, c)
                                            }, 2000);
    return
}

function createCookie(a, b, c) {
    var d, date;
    if (c) {
        date = new Date();
        date.setTime(date.getTime() + (c * 24 * 60 * 60 * 1000));
        d = "; expires=" + date.toGMTString()
    } else {
        d = ""
    }
    document.cookie = encodeURIComponent(a) + "=" + encodeURIComponent(b) + d + "; path=/";
    return
}

function readCookie(a) {
    var b = encodeURIComponent(a) + "=";
    var c = document.cookie.split(';');
    var d, cc;
    for (d = 0; d < c.length; d++) {
        cc = c[d];
        while (cc.charAt(0) === ' ') {
            cc = cc.substring(1, cc.length)
        }
        if (cc.indexOf(b) === 0) {
            return decodeURIComponent(cc.substring(b.length, cc.length))
        }
    }
    return null
}

function eraseCookie(a) {
    createCookie(a, "", -1);
    return
}

function round(a, b) {
    if (b === undefined) {
        b = 2
    }
    var c = Math.pow(10, b);
    return Math.round(a * c) / c
}

function makeid() {
    var a = [],
    ii;
    var b = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    for (ii = 0; ii < 8; ii++) {
        a.push(b.charAt(Math.floor(Math.random() * b.length)))
    }
    return a.join('')
}

function slideUp(a) {
    a.slideUp(200, function() {
              a.remove()
              });
    return
}

function fadeOut(a, b) {
    setTimeout(function() {
               slideUp(a)
               }, b);
    return
}

function ccMenuMsg(a, b, c) {
    if (c === undefined) {
        if (b === 'danger') {
            c = 7500
        } else {
            c = 3500
        }
    }
    var d = [];
    var e = 'menumsg-' + makeid();
    d.push('<div class="alert alert-' + b + ' fade5" id="' + e + '" >');
    d.push('<a class="close">&times;</a>');
    d.push(a);
    d.push('</div>');
    $('.menumsg-inner').append(d.join(''));
    if (b === 'danger') {
        $('.menumsg-inner').css({
                                opacity: 0.9
                                })
    } else {
        $('.menumsg-inner').css({
                                opacity: 0.9
                                })
    } if (c > 0) {
        fadeOut($('#' + e), c)
    }
    $('#' + e).click(function() {
                     slideUp($('#' + e))
                     });
    return
}

function seSave(a, b) {
    createCookie('steamengine-' + a, JSON.stringify(b), 9999);
    ccMenuMsg('設置已保存', 'success');
    return
}

function seLoad(a) {
    var b = readCookie('steamengine-' + a);
    if (b) {
        if (a !== 'theme') {
            ccMenuMsg('加載成功', 'success')
        }
        return $.parseJSON(b)
    }
    return
}

function setCss() {
    var a = $('link#bscss');
    if (a.attr('data-origcss') === undefined) {
        a.attr('data-origcss', a.attr('href'))
    }
    if (choo.bsnm === undefined) {
        choo.bsnm = 'default'
    }
    if (choo.bsnm === 'default') {
        a.attr('href', a.attr('data-origcss'))
    } else {
        a.attr('href', choo.bscss)
    }
    $('#theme').find('.bootswatch[data-nm="' + choo.bsnm + '"]').addClass('bg-success');
    return
}

function themeLoad() {
    var a = seLoad('theme');
    if (a) {
        choo.bscss = a.bscss;
        choo.bsnm = a.bsnm
    } else {
        choo.bscss = '';
        choo.bsnm = 'default'
    }
    setCss();
    return
}

function activateBlinky(a) {
    var b = $(a.attr('data-blink'));
    var c;
    a.css('cursor', 'help').mouseenter(function() {
                                       c = setInterval(function() {
                                                       b.fadeTo(180, 0.2).fadeTo(360, 1.0)
                                                       }, 900);
                                       b.fadeTo(80, 0.2).fadeTo(240, 1.0)
                                       }).mouseleave(function() {
                                                     clearInterval(c)
                                                     });
    return false
}

function activateBlinkies(a) {
    a.find('.blinky').each(function() {
                           activateBlinky($(this))
                           });
    return false
}

function bool2int(b) {
    if (b) {
        return 1
    }
    return 0
}

function observeInputs() {
    $('input').each(function() {
                    var a = $(this);
                    a.focus(function() {
                            choo.inpVal = $(this).val()
                            }).blur(function() {
                                    clearTimeout(choo.inpTimeout)
                                    }).keyup(function() {
                                             clearTimeout(choo.inpTimeout);
                                             choo.inpTimeout = setTimeout(function() {
                                                                          if (choo.inpVal !== a.val() && a.val() !== '') {
                                                                          choo.inpVal = a.val();
                                                                          a.change();
                                                                          a.css('background-color', '#bfffbf');
                                                                          setTimeout(function() {
                                                                                     a.css('background-color', '')
                                                                                     }, 250)
                                                                          }
                                                                          }, 2500)
                                             })
                    });
    return
}

function startSteamEngine() {
    themeLoad();
    activateBlinkies($('body'));
    $('a.wplink').each(function() {
                       $(this).attr('target', '_blank');
                       var t = $(this).attr('title');
                       if (t === undefined) {
                       t = $(this).html()
                       }
                       $(this).attr('title', '維基百科: ' + t + ' (新窗口打開)');
                       $(this).attr('rel', 'nofollow')
                       });
    observeInputs();
    return
}

function right(a, n) {
    if (n <= 0) {
        return ''
    }
    if (n > String(a).length) {
        return a
    }
    var b = String(a).length;
    return String(a).substring(b, b - n)
}

function setHelpClass(b) {
    b.find('*').each(function() {
                     if (this.tagName !== 'A') {
                     var a = $(this).attr('title');
                     if (a !== undefined && a !== '') {
                     $(this).addClass('helpcursor')
                     }
                     }
                     });
    return
}

function getQueryStrings() {
    var a = {};
    var b = function(s) {
        return decodeURIComponent(s.replace(/\+/g, " "))
    };
    var c = location.search.substring(1);
    var d = c.split('&');
    var e, key;
    for (e in d) {
        if (d.hasOwnProperty(e)) {
            key = d[e].split('=');
            if (key.length > 1) {
                if (key[0] !== 'ref') {
                    a[b(key[0])] = b(key[1])
                }
            }
        }
    }
    return a
}

function updateQs(a) {
    a = a.replace('&', '?');
    if (a === '') {
        history.replaceState('', '', '?')
    } else {
        history.replaceState('', '', a)
    }
    return
}

function readNumber(n) {
    return parseFloat(n.replace(',', '.'))
}

function stripMultilineComments(a) {
    var b = [],
    ii, status = 0;
    for (ii = 0; ii < a.length; ii++) {
        if (status === 0) {
            if (a[ii] === '/') {
                status = 1
            } else {
                b.push(a[ii])
            }
        } else if (status === 1) {
            if (a[ii] === '*') {
                status = 2
            } else {
                b.push('/' + a[ii]);
                status = 0
            }
        } else if (status === 2) {
            if (a[ii] === '*') {
                status = 3
            }
        } else if (status === 3) {
            if (a[ii] === '/') {
                status = 0
            } else {
                status = 2
            }
        }
    }
    return b.join('')
}

function stripSinglelineComments(a) {
    var b = [],
    ii, status = 0;
    for (ii = 0; ii < a.length; ii++) {
        if (status === 0) {
            if (a[ii] === '/') {
                status = 1
            } else {
                b.push(a[ii])
            }
        } else if (status === 1) {
            if (a[ii] === '/') {
                status = 2
            } else {
                b.push('/' + a[ii]);
                status = 0
            }
        } else if (status === 2) {
            if (a[ii] === '\n') {
                status = 0
            } else {
                status = 2
            }
        }
    }
    return b.join('')
}

function stripComments(a) {
    var b = stripSinglelineComments(stripMultilineComments(a));
    return b
}

function visAdsenseReklame(a) {
    
}

function visEcmReklame(b) {
    var c = window.AdButler || {};
    c.ads = c.ads || [];
    var d = window.abkw || '';
    if (b.width() > 468) {
        var e = window.plc191008 || 0;
        b.html('<div class="ecmreklame ad728" id="placement_191008_' + e + '"></div>');
        c.ads.push({
                   handler: function(a) {
                   c.register(165395, 191008, [728, 90], 'placement_191008_' + a.place, a)
                   },
                   opt: {
                   place: e++,
                   keywords: d,
                   domain: 'ads.ecigmedia.com'
                   }
                   })
    } else {
        var f = window.plc170954 || 0;
        b.html('<div class="ecmreklame ad468" id="placement_170954_' + f + '"></div>');
        c.ads.push({
                   handler: function(a) {
                   c.register(165395, 170954, [468, 60], 'placement_170954_' + a.place, a)
                   },
                   opt: {
                   place: f++,
                   keywords: d,
                   domain: 'ads.ecigmedia.com'
                   }
                   })
    }
    b.find('img').removeAttr('width').removeAttr('height');
    setTimeout(function() {
               b.find('img').removeAttr('width').removeAttr('height')
               }, 125);
    setTimeout(function() {
               b.find('img').removeAttr('width').removeAttr('height')
               }, 250);
    setTimeout(function() {
               b.find('img').removeAttr('width').removeAttr('height')
               }, 500);
    setTimeout(function() {
               b.find('img').removeAttr('width').removeAttr('height')
               }, 1000);
    setTimeout(function() {
               b.find('img').removeAttr('width').removeAttr('height')
               }, 2000);
    setTimeout(function() {
               b.find('img').removeAttr('width').removeAttr('height')
               }, 4000);
    setTimeout(function() {
               b.find('img').removeAttr('width').removeAttr('height')
               }, 8000);
    return
}

function visEcmReklameMedFallback(a) {
    a.css('min-height', '60px').html('<center></center>');
    var b = a.find('center:first');
    setTimeout(function() {
               visEcmReklame(b);
               setTimeout(function() {
                          if (b.find('img').length === 0) {
                          a.css('min-height', '').after('<div id="fallbackreklame" style="min-height:60px;"></div>');
                          visAdsenseReklame($('#fallbackreklame'))
                          }
                          }, 1500)
               }, 1);
    return
}

function sjekkReklame() {
    var a = $('.ecmreklame img').length;
    var b = $('.adsensereklame iframe').length;
    var c;
    if (a > 0 && b > 0) {
        c = 'ecm+abg'
    } else if (a > 0) {
        c = 'ecm'
    } else if (b > 0) {
        c = 'abg'
    } else {
        c = 'ingen';
        choo.adblokket = true
    }
    var d = 'ecmshow: ' + a + ', abgshow: ' + b;
    gad('adshow', c, d);
    return
}

function visEnAvToReklame(a) {
    var b = 0;
    var c = parseInt($('body').attr('data-ecmpro'), 10);
    var d = Math.random() * 100;
    if (d > c) {
        visAdsenseReklame(a)
    } else {
        var e = setInterval(function() {
                            if (window.AdButler) {
                            clearInterval(e);
                            visEcmReklameMedFallback(a)
                            }
                            b++;
                            if (b > 100) {
                            clearInterval(e)
                            }
                            }, 20)
    }
    return
}

function sjekkOgVisReklamer() {
    var a = $('body').width(),
    xx, $bunn = $('#bunnreklame'),
    $topp = $('#toppreklame');
    if ($('#matchedcontent').length > 0) {
        (adsbygoogle = window.adsbygoogle || []).push({})
    }
    if ($bunn.length > 0) {
        if (a <= 1900) {
            visEnAvToReklame($bunn)
        } else {
            xx = [];
            xx.push('<div class="row">');
            xx.push('<div class="col col-md-6"><div id="bunnreklame1"></div></div>');
            xx.push('<div class="col col-md-6"><div id="bunnreklame2"></div></div>');
            xx.push('</div>');
            $bunn.html(xx.join(''));
            visAdsenseReklame($('#bunnreklame1'));
            visEnAvToReklame($('#bunnreklame2'))
        }
    }
    if ($topp.length > 0) {
        visAdsenseReklame($topp)
    }
    return
}

$(document).ready(function() {
                  choo.sidenavn = $('body').attr('id');
                  $('.menumsg').html('<div class="menumsg-inner"></div>');
                  startSteamEngine();
                  setHelpClass($('body'));
                  $('.howdoesitwork').hide();
                  $('a[target="_blank"]').click(function() {
                                                gad('eksternlink', $(this).text(), $(this).attr('href'))
                                                });
                  sjekkOgVisReklamer();
                  setTimeout(function() {
                             sjekkReklame()
                             }, 3000);
                  $('#howdoesitwork').click(function() {
                                            $(this).toggleClass('active');
                                            $('.howdoesitwork').toggle('fold')
                                            });
                  });